﻿-- bugs: self is found as [LF]

-- search for these words in the chattext (uppercase needed)
local matchChecks    = {"LF[MG]?", "SUCHEN", "SUCHE", "SUCHT"}

function strip(s)
   -- strip text in the beginning and in the end
   return s:gsub("^%s+", ""):gsub("%s+$", "")
end

function noChatFnc(self, event, txt, ...) -- (self, event, txt, sender, ...)
   local arg={...}
   sender   = arg[1];
   channel  = arg[6];
   
   -- Check if chat was posted in one of the 4 main channels
   if (channel == 1 or channel == 2 or channel == 3 or channel == 4) then
      txt = strip(txt)
      upperTxt = string.upper(txt);
      
      fStart   = nil;
      fEnd     = nil;
      found = false
      
      -- Loop trough the matches on top. If a match is found break the loop and go on
      for i, checkStr in ipairs(matchChecks) do
         -- lfStr = (string.find(upperTxt, "LF[MG]"));
         fStart, fEnd = string.find(upperTxt, string.format("(%s)", checkStr))
         if (fStart and fEnd) then
            found = true;
            break
         end
      end
      
      -- If something was found change the text match to some more visible text
      if (found) then
         txtColor    = "cFFff7f50"
         lfEditTxt   = string.format("[%s]", string.sub(txt, fStart, fEnd)):upper()
         if (fStart > 1) then
            if (fEnd < upperTxt:len()) then
               outStr = string.format("%s|%s%s|r%s", string.sub(txt, 1, fStart-1), txtColor, lfEditTxt, string.sub(txt, fEnd+1));
            else
               outStr = string.format("%s|%s%s", string.sub(txt, 1, fStart-1), txtColor, lfEditTxt);
            end
         else
            outStr = string.format("|%s%s|r%s", txtColor, lfEditTxt, string.sub(txt, fEnd+1));
         end
         
         -- This is needed to replace the original text with our modified
         return false, outStr, ...
      end
   end
end

-- Add the chat-channel listener event
ChatFrame_AddMessageEventFilter("CHAT_MSG_CHANNEL", noChatFnc);